Package com.oracle.truffle.api.object

## Class Shape.Allocator

- java.lang.Object
- - com.oracle.truffle.api.object.Shape.Allocator

Direct Known Subclasses:
  `ShapeImpl.BaseAllocator`

Enclosing class:
  Shape

    public abstract static class Shape.Allocator
    extends java.lang.Object

### Constructor Summary

Constructors
`Allocator()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract Shape.Allocator` `addLocation​(Location location)`
`abstract Location` `constantLocation​(java.lang.Object value)`
`abstract Location` `declaredLocation​(java.lang.Object value)`
`Location` `locationForType​(java.lang.Class<?> type)`
`protected abstract Location` `locationForType​(java.lang.Class<?> type, boolean useFinal, boolean nonNull)`
`Location` `locationForType​(java.lang.Class<?> type, java.util.EnumSet<LocationModifier> modifiers)`
`Location` `locationForValue​(java.lang.Object value)`
`protected abstract Location` `locationForValue​(java.lang.Object value, boolean useFinal, boolean nonNull)`
`Location` `locationForValue​(java.lang.Object value, java.util.EnumSet<LocationModifier> modifiers)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Allocator

    public Allocator()

### Method Detail

#### locationForValue

    protected abstract Location locationForValue​(java.lang.Object value,
                                                 boolean useFinal,
                                                 boolean nonNull)

#### locationForValue

    public final Location locationForValue​(java.lang.Object value)

#### locationForValue

    public final Location locationForValue​(java.lang.Object value,
                                           java.util.EnumSet<LocationModifier> modifiers)

#### locationForType

    protected abstract Location locationForType​(java.lang.Class<?> type,
                                                boolean useFinal,
                                                boolean nonNull)

#### locationForType

    public final Location locationForType​(java.lang.Class<?> type)

#### locationForType

    public final Location locationForType​(java.lang.Class<?> type,
                                          java.util.EnumSet<LocationModifier> modifiers)

#### constantLocation

    public abstract Location constantLocation​(java.lang.Object value)

#### declaredLocation

    public abstract Location declaredLocation​(java.lang.Object value)

#### addLocation

    public abstract Shape.Allocator addLocation​(Location location)